c
c   (C) 2000 UNIVERSITY OF CHICAGO
c        See COPYRIGHT in top-level directory.
c




c
c Fortran example program 1
c
c Processor 0 sends an array to the other processors and they 
c print the array contents.
c

      program example1

      include 'autopack.fh'

      integer ierror
      integer nprocs, rank
      integer count
      integer senddata(4), recdata(4)
      integer rbuf, size, sender, tag, status


      call MPI_INIT(ierror)
      call AP_INIT

c get the number of processors and rank

      call AP_SIZE(nprocs)
      call AP_RANK(rank)

c processor 0 sends 
c the other processors receive
      
      if (rank.eq.0) then

        do j=1,nprocs-1
          do i=1,4
            senddata(i)= j*100+i
          enddo

c         AP_BSEND( data, bytes, destination processor, tag)

          call AP_BSEND(senddata,4*4,j,55)
        enddo

        call AP_FLUSH()
        call AP_CHECK_SENDS(AP_WAITALL,count)

      else

        call AP_RECV(MPI_ANY_SOURCE,MPI_ANY_TAG,AP_BLOCKING,
     1               rbuf, size, sender, tag,
     2               status)


c rbuf is a pointer (stored in an integer) to the received message
c copy the data into the fortran array recdata() and free the pointer

        call AP_COPY_FREE(recdata,rbuf,size)

        write(*,99) rank,sender,recdata
 99     format (1x,'my rank ',i2,'  sender ',i2,'  received: ',4I4)

      endif


      call AP_FINALIZE()
      call MPI_FINALIZE(ierror)

      stop
      end

