c
c   (C) 2000 UNIVERSITY OF CHICAGO
c        See COPYRIGHT in top-level directory.
c






      program ftest

      implicit none

      include 'autopack.fh'

      integer i,j,k

      integer ierror
      integer nprocs, mypid

      integer data(4), newdata(4)

      integer recv_buf, recv_size, recv_sender, recv_tag, recv_status

      integer tag
      integer count, done
      integer sendcount


      call MPI_INIT(ierror)
      call AP_INIT

c     AP_SETPARAM( package size,
c                  packing on (1) or off (0),
c                  max simultaneous mpi sends to a single proc,
c                  max simultaneous mpi sends to all procs )

      call AP_SETPARAM(1024,1,10,10)

      call AP_NPROCS(nprocs)
      call AP_MYPID(mypid)


      call AP_SEND_BEGIN(tag)

      if (mypid.eq.0) then

        do k=1,nprocs-1
          do j=1,k
            do i=1,4
              data(i)= k*10000+j*100+i
            enddo

            call AP_BSEND(data,4*4,k,tag)
          enddo
        enddo

        call AP_FLUSH()
      endif

      call AP_SEND_END()

      i=0

 100  continue
      call AP_RECV_COUNT(count,done)
      if (done.eq.0 .or. i.lt.count) then

        call AP_RECV(MPI_ANY_SOURCE,tag,AP_BLOCKING+AP_DROPOUT,
     1               recv_buf, recv_size, recv_sender, recv_tag,
     2               recv_status)

        if (recv_status.ne.0) then
          call AP_COPY_FREE(newdata,recv_buf,recv_size)
          write (6,*) mypid,recv_sender,newdata
          i=i+1
        endif

        goto 100
      endif

      call AP_CHECK_SENDS(AP_WAITALL,sendcount)

      call sleep(1)
      write (6,*) mypid,' Done receiving, number of receives=',count

      call MPI_FINALIZE(ierror)

      stop
      end

