c
c   (C) 2000 UNIVERSITY OF CHICAGO
c        See COPYRIGHT in top-level directory.
c




cccccccccccccccccccccccccccccccccccccc

      subroutine send1

      include 'autopack.fh'
      implicit none

      integer i,j,k
      integer nprocs, mypid
      integer data(4), newdata(4)
      integer recv_buf, recv_size, recv_sender, recv_tag, recv_status
      integer tag
      integer count, done

      call AP_NPROCS(nprocs)
      call AP_MYPID(mypid)

      call AP_SEND_BEGIN(tag)

      if (mypid.eq.0) then

        do k=1,nprocs-1
          do j=1,k
            do i=1,4
              data(i)= k*10000+j*100+i
            enddo

            call AP_BSEND(data,4*4,k,tag)
          enddo
        enddo

        call AP_FLUSH()
      endif

      call AP_SEND_END()

      i=0

 100  continue
      call AP_RECV_COUNT(count,done)
      if (done.eq.0 .or. i.lt.count) then

        call AP_RECV(MPI_ANY_SOURCE,tag,AP_BLOCKING+AP_DROPOUT,
     1               recv_buf, recv_size, recv_sender, recv_tag,
     2               recv_status)

        if (recv_status.ne.0) then
          call AP_COPY_FREE(newdata,recv_buf,recv_size)
          i=i+1
        endif

        goto 100
      endif

      write (6,*) 'Round 1 ',mypid,' receives ',count

      if (count.ne.mypid) then
        write (6,*) '******',mypid,' Bad count',count
      endif

      call AP_CHECK_SENDS(AP_WAITDEFER,count)
      if (count.gt.0) then
         write (6,*) '*****',mypid,' Number of pending sends',count
      endif

      if (mypid.eq.0) write (6,*)
      return
      end


cccccccccccccccccccccccccccccccccccccc

      subroutine send2

      include 'autopack.fh'
      implicit none

      integer i,j,k
      integer nprocs, mypid
      integer data(4), newdata(4)
      integer recv_buf, recv_size, recv_sender, recv_tag, recv_status
      integer tag
      integer count, done

      call AP_NPROCS(nprocs)
      call AP_MYPID(mypid)

      call AP_SEND_BEGIN(tag)

      do j=1,3
        do i=1,4
          data(i)= k*10000+j*100+i
        enddo

        call AP_BSEND(data,4*4,mod(mypid+j,nprocs),tag)
      enddo

      call AP_FLUSH()

      call AP_SEND_END()

      i=0
 100  continue
      call AP_RECV_COUNT(count,done)
      if (done.eq.0 .or. i.lt.count) then

        call AP_RECV(MPI_ANY_SOURCE,tag,AP_BLOCKING+AP_DROPOUT,
     1               recv_buf, recv_size, recv_sender, recv_tag,
     2               recv_status)

        if (recv_status.ne.0) then
          call AP_COPY_FREE(newdata,recv_buf,recv_size)
          i=i+1
        endif

        goto 100
      endif

      write (6,*) 'Round 2 ',mypid,' receives ',count

      if (count.ne.3) then
        write (6,*) '******',mypid,' Bad count',count
      endif

      call AP_CHECK_SENDS(AP_WAITDEFER,count)
      if (count.gt.0) then
         write (6,*) '*****',mypid,' Number of pending sends',count
      endif

      if (mypid.eq.0) write (6,*)
      return
      end

cccccccccccccccccccccccccccccccccccccc

      subroutine send3

      include 'autopack.fh'
      implicit none

      integer i,j,k
      integer nprocs, mypid
      integer data(4), newdata(4)
      integer recv_buf, recv_size, recv_sender, recv_tag, recv_status
      integer tag
      integer count, done

      call AP_NPROCS(nprocs)
      call AP_MYPID(mypid)

      call AP_SEND_BEGIN(tag)

      do j=0,nprocs
        if (mod(j,2).ne.0.and.mod(mypid,2).ne.0) then

          do i=1,4
            data(i)= j*100+i
          enddo

          call AP_BSEND(data,4*4,j,tag)

        endif
      enddo

      call AP_FLUSH()

      call AP_SEND_END()

      i=0
 100  continue
      call AP_RECV_COUNT(count,done)
      if (done.eq.0 .or. i.lt.count) then

        call AP_RECV(MPI_ANY_SOURCE,tag,AP_BLOCKING+AP_DROPOUT,
     1               recv_buf, recv_size, recv_sender, recv_tag,
     2               recv_status)

        if (recv_status.ne.0) then
          call AP_COPY_FREE(newdata,recv_buf,recv_size)
          i=i+1
        endif

        goto 100
      endif

      write (6,*) 'Round 3 ',mypid,' receives ',count

      if (mod(mypid,2).ne.0) then
        if (count.ne.nprocs/2) then
          write (6,*) '******',mypid,' Bad count',count
        endif
      else
        if (count.ne.0) then
          write (6,*) '******',mypid,' Bad count',count
        endif
      endif

      call AP_CHECK_SENDS(AP_WAITDEFER,count)
      if (count.gt.0) then
         write (6,*) '*****',mypid,' Number of pending sends',count
      endif

      if (mypid.eq.0) write (6,*)
      return
      end


cccccccccccccccccccccccccccccccccccccc




      program ftest

      implicit none
      include 'autopack.fh'

      integer ierror

      call MPI_INIT(ierror)
      call AP_INIT

      call AP_SETPARAM(1024,1,10,10)

      call send1
      call send2
      call send3

      call MPI_FINALIZE(ierror)

      stop
      end

